#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup() {
	
	ofBackground(0, 0, 0);
	ofSetLogLevel(OF_LOG_NOTICE);
	ofSetVerticalSync(true);
	
	// Box2d
	box2d.init();
	box2d.setGravity(0, 20);
	box2d.createFloor();
	box2d.setFPS(30.0);
	
	
	
}


//--------------------------------------------------------------
void testApp::update() {
	
	
	box2d.update();	
	
	for(int i=0; i<triangles.size(); i++) {
		triangles[i].update();
		
		// try these out
		//triangles[i].addAttractionPoint(ofGetWidth()/2, ofGetHeight()/2, 0.20);
		//triangles[i].addDamping(0.043);
	}
}

//--------------------------------------------------------------
void testApp::draw() {
	
	box2d.draw();
	
	for(int i=0; i<triangles.size(); i++) triangles[i].draw();
	
	string info = "FPS: "+ofToString(ofGetFrameRate());
	ofSetColor(255, 255, 0);
	ofDrawBitmapString(info, 20, 20);
}


//--------------------------------------------------------------
void testApp::keyPressed(int key) {
	
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ) {
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button) {
	
	/*
	Triangle Setup
		  C
	    /   \
	   /     \
	  /       \
	 A ------- B
    
	*/
	
	ofPoint a, b, c;
	a.set(0, 0);
	b.set(ofRandom(10, 100), 0);
	c.set(b.x-3, ofRandom(5, 40));
	
	ofxBox2dPolygon tri;
	tri.setPhysics(10.0, 0.4, 0.003);
	tri.addVertex(a);
	tri.addVertex(b);
	tri.addVertex(c);
	tri.createShape(box2d.getWorld(), x, y);
	triangles.push_back(tri);	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button) {
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button) {

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h) {
}

